var controllers, listen;
controllers = {
  article: require('./articleController'),
  error: require('./errorController')
};
listen = function(configs) {
  var connect, server;
  connect = require('connect');
  configs != null ? configs : configs = {};
  server = connect.createServer();
  if (configs.env === 'dev') {
    server.use(connect.logger());
    server.use(connect.profiler());
    server.use(connect.responseTime());
  }
  if (configs.favicon) {
    server.use(connect.favicon(configs.favicon));
  }
  if (configs.staticDir) {
    server.use(connect.static(configs.staticDir));
  }
  server.use(connect.router(exports.controllers.article.app(configs)));
  if (configs.env === 'dev') {
    server.use(connect.errorHandler({
      stack: true,
      dump: true,
      message: true
    }));
  } else {
    server.use(connect.router(function(app) {
      var func;
      func = exports.controllers.error(configs);
      return app.get(/.*/, function(req, res, next) {
        return next(new Error(404));
      });
    }));
    server.use(exports.controllers.error(configs));
    process.on('uncaughtException', function(err) {
      return process.stderr.write(err + "\n");
    });
  }
  return server.listen(configs.port || 8080, configs.host || '127.0.0.1');
};
/*
Module Exports
*/
exports.listen = listen;
exports.controllers = controllers;